//+------------------------------------------------------------------+
//|                                               SHE_GoldenBall.mq4 |
//|                                         Copyright  2008, Shurka |
//|                                          http://tradenetsoft.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Shurka"
#property link      "shurka@tradenetsoft.net"

extern int           BuyLevel=10;
extern int           SellLevel=10;
extern int           StopLoss=20;
extern int           TakeProfit=40;
extern int           TradeTime=0;
extern int           TrailStop=0;
extern double        Lots=0.01;
extern int           Slippage=3;
extern string        OrdersComment="SHE_GoldenBall";

int                  i,MAGIC,BS,STP,SPR;
double               Lot,ur,sl,tp,MaxLots,MinLots,StepLots;
string               CMM;
bool                 b,s,bs,ss,Trade;
datetime             ltt;

int init()//==================================================================================================
{
   MAGIC=20408+StringGetChar(Symbol(),0)+StringGetChar(Symbol(),1)*2
   +StringGetChar(Symbol(),3)*3+StringGetChar(Symbol(),4)*4+Period()*100000;
   //   
   MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   StepLots=MarketInfo(Symbol(),MODE_LOTSTEP);
   Lot=GlobalVariableGet("SHI_Lots");  if(Lot<=0) Lot=Lots;
   if(Lot<MinLots) Lot=MinLots; else
   if(Lot>MaxLots) Lot=MaxLots; else
   Lot=NormalizeDouble(Lot/StepLots,0)*StepLots;
   CMM=OrdersComment+" Magic#="+MAGIC;
   return(0);
}
//============================================================================================================
//  
int start()
{
   //   .
   if(!IsTesting())
   {
      if(!IsExpertEnabled()) { Comment("     ."); return(0); } else
      if(!IsTradeAllowed()) { Comment("     ."); return(0); } else Comment("");
   }
   STP=MarketInfo(Symbol(),MODE_STOPLEVEL);
   SPR=MarketInfo(Symbol(),MODE_SPREAD);
   if(Hour()==TradeTime && TimeHour(Time[1])!=Hour()) ltt=Time[0];
   if(Hour()!=TradeTime) Trade=true;
   //    ---------------------------------------------------------------------------
   for(b=false,s=false,i=OrdersTotal()-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=MAGIC || OrderType()>OP_SELL) continue;
      if(OrderType()==OP_SELL)
      {
         if(OrderOpenTime()<ltt) OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,CLR_NONE); else
         {
            s=true;
            if(TrailStop>=STP)
            {
               if(OrderOpenPrice()-Ask>TrailStop*Point && (OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()==0))
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
               else if(OrderOpenPrice()-Ask>TrailStop*Point && OrderStopLoss()>Ask+TrailStop*Point
               && OrderStopLoss()<=OrderOpenPrice())
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+TrailStop*Point,Digits),OrderTakeProfit(),0,CLR_NONE);
            }
         }
      } else
      if(OrderType()==OP_BUY)
      {
         if(OrderOpenTime()<ltt) OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,CLR_NONE); else
         {
            b=true;
            if(TrailStop>=STP)
            {
               if(Bid-OrderOpenPrice()>TrailStop*Point && OrderStopLoss()<OrderOpenPrice())
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
               else if(Bid-OrderOpenPrice()>TrailStop*Point && OrderStopLoss()<Bid-TrailStop*Point
               && OrderStopLoss()>=OrderOpenPrice())
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-TrailStop*Point,Digits),OrderTakeProfit(),0,CLR_NONE);
            }
         }
      }
   }
   //    ---------------------------------------------------------------------------
   for(bs=false,ss=false,i=OrdersTotal()-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=MAGIC || OrderType()<=OP_SELL) continue;
      if(OrderType()==OP_SELLSTOP)
      {
         if(OrderOpenTime()<ltt || b) OrderDelete(OrderTicket()); else ss=true;
      } else
      if(OrderType()==OP_BUYSTOP)
      {
         if(OrderOpenTime()<ltt || s) OrderDelete(OrderTicket()); else bs=true;
      }
   }
   if((b || bs) && (s || ss) && Hour()==TradeTime) Trade=false;
   RefreshRates();
   if(!b && !bs && Trade && Hour()==TradeTime)
   {
      ur=NormalizeDouble(Ask+BuyLevel*Point,Digits);
      if(StopLoss<STP+SPR) sl=0; else sl=NormalizeDouble(ur-StopLoss*Point,Digits);
      if(TakeProfit<STP-SPR || TakeProfit==0) tp=0; else tp=NormalizeDouble(ur+TakeProfit*Point,Digits);
      OrderSend(Symbol(),OP_BUYSTOP,Lot,ur,0,sl,tp,CMM,MAGIC,0,Red);
   }
   if(!s && !ss && Trade && Hour()==TradeTime)
   {
      ur=NormalizeDouble(Bid-SellLevel*Point,Digits);
      if(StopLoss<STP+SPR) sl=0; else sl=NormalizeDouble(ur+StopLoss*Point,Digits);
      if(TakeProfit<STP-SPR || TakeProfit==0) tp=0; else tp=NormalizeDouble(ur-TakeProfit*Point,Digits);
      OrderSend(Symbol(),OP_SELLSTOP,Lot,ur,0,sl,tp,CMM,MAGIC,0,Blue);
   }
   return(0);
}
